<?php

/**
 * certif_dian_contra actions.
 * Cambio de id_tercero por num_doc, para la agrupacion - 20150908
 * Se agrega para la consulta de interceros erp_sgr. para consultar el tercero del SGR - 20150909
 *
 * @package    nomina
 * @subpackage certif_dian_contra
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class certif_dian_contraActions extends sfActions {

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' order by tab0.id_anhos , tab0.num_doc  ';
        }

        //Contratista

        if (isset($request['id_mae_ter'])) {
            $whereContratista = " AND tab0.id_tercero = " . $request['id_mae_ter'];
        } else {
            $whereContratista = ' ';
        }

        if (isset($request['num_doc'])) {
            $whereFuncionarioNumDoc = " AND tab0.num_doc = '" . $request['num_doc'] . "'";
        } else {
            $whereFuncionarioNumDoc = ' ';
        }


        //sentencia sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
        //ejecuta y obtiene el resultado del sql
        CN_TABLE::executeSQL($sql);


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];


            /*
             * Variables opcionales
             */

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select tab0.* from(

    select
                    
    (select secuencia from cont_consecutivo_certif where num_doc = tab0.num_doc and id_anhos = $id_anhos ) as secuencia,
    tab1.id_tipo_doc,
    tab0.ID_ANHOS,tab0.NUM_DOC,tab0.RAZON_SOC,tab1.mail as email

    FROM TS_CERTIFICADO_RETEN tab0
                    
    LEFT JOIN INTERCEROS_DU_DIR_V tab1 ON tab1.num_doc = tab0.num_doc  

    where tab0.id_anhos = $id_anhos
    and ( tab0.num_doc,tab0.id_anhos ) in (
        --( 34951, 1, 2014 )
            select distinct
            --tab0.id_tercero,
            (select interceros.num_doc from interceros where id_mae_ter = tab0.id_tercero) as num_doc,
            tab0.vigencia
            from ts_pago_obl tab0
            join ts_obligacion tab1 ON tab1.id_obligacion = tab0.id_obligacion AND  tab1.secuencia = tab0.secuencia and tab1.ano_fiscal = tab0.vigencia and tab1.id_vigencia = tab0.id_vigencia
            JOIN(
                select 
                tab0.id_obligacion,tab0.secuencia,
                tab0.id_vigencia,tab0.ano_fiscal,sum(tab0.VALOR_IMPUESTO) as valor
                from ts_deducciones tab0 
                where tab0.id_im in (47 , 48, 32)  
                group by tab0.id_obligacion, 
                tab0.secuencia, tab0.id_vigencia, tab0.ano_fiscal
            ) tab12 ON tab12.id_obligacion = tab1.id_obligacion and tab12.secuencia = tab1.secuencia and tab12.ano_fiscal = tab1.ano_fiscal and tab12.id_vigencia  = tab1.id_vigencia
            
            union
            
            select distinct
            --tab0.id_tercero,
            (select interceros.num_doc from erp_sgr.interceros where id_mae_ter = tab0.id_tercero) as num_doc,
            tab0.vigencia
            from erp_sgr.ts_pago_obl tab0
            join erp_sgr.ts_obligacion tab1 ON tab1.id_obligacion = tab0.id_obligacion AND  tab1.secuencia = tab0.secuencia and tab1.ano_fiscal = tab0.vigencia and tab1.id_vigencia = tab0.id_vigencia
            JOIN(
                select 
                tab0.id_obligacion,tab0.secuencia,
                tab0.id_vigencia,tab0.ano_fiscal,sum(tab0.VALOR_IMPUESTO) as valor
                from erp_sgr.ts_deducciones tab0 
                where tab0.id_im in (48 , 49, 32)  
                group by tab0.id_obligacion, 
                tab0.secuencia, tab0.id_vigencia, tab0.ano_fiscal
            ) tab12 ON tab12.id_obligacion = tab1.id_obligacion and tab12.secuencia = tab1.secuencia and tab12.ano_fiscal = tab1.ano_fiscal and tab12.id_vigencia  = tab1.id_vigencia


        )           
                    
)tab0
                    
WHERE
1 = 1
$whereFuncionarioNumDoc  
       
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.* from(

    select
                    
    (select secuencia from cont_consecutivo_certif where num_doc = tab0.num_doc and id_anhos = $id_anhos ) as secuencia,
    tab1.id_tipo_doc,
    tab0.ID_ANHOS,tab0.NUM_DOC,tab0.RAZON_SOC,tab1.mail as email

    FROM TS_CERTIFICADO_RETEN tab0
                    
    LEFT JOIN INTERCEROS_DU_DIR_V tab1 ON tab1.num_doc = tab0.num_doc  

    where tab0.id_anhos = $id_anhos
    and ( tab0.num_doc,tab0.id_anhos ) in (
        --( 34951, 1, 2014 )
            select distinct
            --tab0.id_tercero,
            (select interceros.num_doc from interceros where id_mae_ter = tab0.id_tercero) as num_doc,
            tab0.vigencia
            from ts_pago_obl tab0
            join ts_obligacion tab1 ON tab1.id_obligacion = tab0.id_obligacion AND  tab1.secuencia = tab0.secuencia and tab1.ano_fiscal = tab0.vigencia and tab1.id_vigencia = tab0.id_vigencia
            JOIN(
                select 
                tab0.id_obligacion,tab0.secuencia,
                tab0.id_vigencia,tab0.ano_fiscal,sum(tab0.VALOR_IMPUESTO) as valor
                from ts_deducciones tab0 
                where tab0.id_im in (47 , 48, 32)  
                group by tab0.id_obligacion, 
                tab0.secuencia, tab0.id_vigencia, tab0.ano_fiscal
            ) tab12 ON tab12.id_obligacion = tab1.id_obligacion and tab12.secuencia = tab1.secuencia and tab12.ano_fiscal = tab1.ano_fiscal and tab12.id_vigencia  = tab1.id_vigencia
            
            union
            
            select distinct
            --tab0.id_tercero,
            (select interceros.num_doc from erp_sgr.interceros where id_mae_ter = tab0.id_tercero) as num_doc,
            tab0.vigencia
            from erp_sgr.ts_pago_obl tab0
            join erp_sgr.ts_obligacion tab1 ON tab1.id_obligacion = tab0.id_obligacion AND  tab1.secuencia = tab0.secuencia and tab1.ano_fiscal = tab0.vigencia and tab1.id_vigencia = tab0.id_vigencia
            JOIN(
                select 
                tab0.id_obligacion,tab0.secuencia,
                tab0.id_vigencia,tab0.ano_fiscal,sum(tab0.VALOR_IMPUESTO) as valor
                from erp_sgr.ts_deducciones tab0 
                where tab0.id_im in (48 , 49, 32)  
                group by tab0.id_obligacion, 
                tab0.secuencia, tab0.id_vigencia, tab0.ano_fiscal
            ) tab12 ON tab12.id_obligacion = tab1.id_obligacion and tab12.secuencia = tab1.secuencia and tab12.ano_fiscal = tab1.ano_fiscal and tab12.id_vigencia  = tab1.id_vigencia


        )           
                    
)tab0
                    
WHERE
1 = 1
$whereFuncionarioNumDoc    
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[res_autoliquida_consol] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Generar no formularios Contratistas
     *
     * @param sfRequest $request A request object
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }


        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);

        try {

            /*
             * Variables de filtro
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $fecha_expe = $request['fecha_expe'];
            $progress_key = $request['progress_key'] . $request['username'];

            //Funcionario num_doc
            $id_mae_ter = null;
            $whereTercero = "";
            if (isset($request['id_mae_ter'])) {
                $id_mae_ter = $request['id_mae_ter'];
                $whereTercero = " AND tab0.id_tercero = " . $request['id_mae_ter'];
            }

            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND ter.num_doc = '" . $request['num_doc'] . "'";
            } else {
                $whereFuncionarioNumDoc = ' ';
            }

            /*
             * Generar consecutivos por persona y vigencia, ANM y SGR
             */
            //Sql
            $sql = <<<EOD
select 
tab0.num_doc,
tab0.vigencia
from (

          select distinct
            (select interceros.num_doc from interceros where id_mae_ter = tab0.id_tercero) as num_doc,
            tab0.id_tercero,
            tab0.vigencia
            from ts_pago_obl tab0
            join ts_obligacion tab1 ON tab1.id_obligacion = tab0.id_obligacion AND  tab1.secuencia = tab0.secuencia and tab1.ano_fiscal = tab0.vigencia and tab1.id_vigencia = tab0.id_vigencia
            JOIN(
                select 
                tab0.id_obligacion,tab0.secuencia,
                tab0.id_vigencia,tab0.ano_fiscal,sum(tab0.VALOR_IMPUESTO) as valor
                from ts_deducciones tab0 
                where tab0.id_im in (47 , 48, 32)  
                group by tab0.id_obligacion, 
                tab0.secuencia, tab0.id_vigencia, tab0.ano_fiscal
            ) tab12 ON tab12.id_obligacion = tab1.id_obligacion and tab12.secuencia = tab1.secuencia and tab12.ano_fiscal = tab1.ano_fiscal and tab12.id_vigencia  = tab1.id_vigencia
            
            union
            
            select distinct
            (select interceros.num_doc from erp_sgr.interceros where id_mae_ter = tab0.id_tercero) as num_doc,
            tab0.id_tercero,
            tab0.vigencia
            from erp_sgr.ts_pago_obl tab0
            join erp_sgr.ts_obligacion tab1 ON tab1.id_obligacion = tab0.id_obligacion AND  tab1.secuencia = tab0.secuencia and tab1.ano_fiscal = tab0.vigencia and tab1.id_vigencia = tab0.id_vigencia
            JOIN(
                select 
                tab0.id_obligacion,tab0.secuencia,
                tab0.id_vigencia,tab0.ano_fiscal,sum(tab0.VALOR_IMPUESTO) as valor
                from erp_sgr.ts_deducciones tab0 
                where tab0.id_im in (48 , 49, 32)  
                group by tab0.id_obligacion, 
                tab0.secuencia, tab0.id_vigencia, tab0.ano_fiscal
            ) tab12 ON tab12.id_obligacion = tab1.id_obligacion and tab12.secuencia = tab1.secuencia and tab12.ano_fiscal = tab1.ano_fiscal and tab12.id_vigencia  = tab1.id_vigencia

)tab0

left join interceros_v ter
on ter.num_doc = tab0.num_doc

where
tab0.vigencia = $id_anhos
$whereFuncionarioNumDoc                    

order by
ter.num_doc
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            foreach ($records as $value) {

                $num_doc = $value['num_doc'];

                try {
                    //insertar 
                    $sql = <<<EOD
insert into cont_consecutivo_certif (id_consecutivo_certif,num_doc,id_anhos,secuencia) 
    values ( null, $num_doc, $id_anhos, (select nvl( max(secuencia) ,0) + 1 from cont_consecutivo_certif where id_anhos = $id_anhos) ) 
EOD;
                    //ejecuta sql
                    CN_TABLE::executeSQL($sql);
                } catch (Exception $exc) {
//                    echo $exc->getTraceAsString();
                }
            }


            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->status = 0;
            $this->list_data = array();
            $this->logMessage("[certif_dian_contra] Generació exitosa");
        } catch (Exception $e) {
            MemcacheHandler::getInstance()->set($progress_key, 100);

            $this->status = 1;
            $this->mensajeError = "[certif_dian_contra] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[certif_dian_contra] ERROR!");
            $this->logMessage($e->getMessage());
        }
    }

}
